/*
 *  WCOL: basic (path, URL handling) procedures
 *      by k-chinen@is.aist-nara.ac.jp, 1994, 1995, 1996
 *
 * $Id: base.h,v 1.4 1995/10/09 10:11:55 k-chinen Exp k-chinen $
 */

#ifndef WCOL_BASE_H
#define WCOL_BASE_H     /* block of forever(or nest) loop */



#ifndef CACHELOCKTIME
#define CACHELOCKTIME           (60*10)                 /* 10 min. */
#endif



#define PADDING_NAME    "_noname_.html"


#define INFO_EXT        ",info"
#define HIST_EXT        ",hist"
#define LOCK_EXT        ",lock"
#define REQUEST_EXT     ",req"
#define FACE_EXT        ",face"
#define NOTE_EXT        ",note"

#define HEAD_EXT        ",head"
#define HEAD_TMP_EXT    ",tmp-head"
#define BODY_TMP_EXT    ",tmp-body"
#define OLD_EXT         ",old"


#define UNKNOW_FILE     (0x0000)
#define INFO_FILE       (0x0001)
#define HIST_FILE       (0x0002)
#define LOCK_FILE       (0x0004)
#define REQUEST_FILE    (0x0008)
#define FACE_FILE       (0x0010)
#define NOTE_FILE       (0x0020)

#define HEAD_FILE       (0x0100)
#define HEAD_TMP_FILE   (0x1100)      /* 0x1000 | 0x0100 */
#define BODY_FILE       (0x0200)
#define BODY_TMP_FILE   (0x1200)      /* 0x1000 | 0x0200 */


#ifndef HOSTNAME_HASH_RADIX
#define HOSTNAME_HASH_RADIX     (53)
#endif
extern int hostname_hash_radix;



/*
 * Retry LOCKRETRY_INTERVAL seconds x LOCKRETRY_TIME times.
 */
#define LOCKRETRY_TIME      (5)
#define LOCKRETRY_INTERVAL  (5)


#define TH_COUNT        (0)
#define TH_TIME         (10000)




#ifdef HAVE_DIRENT
                                    /* have dirent, SYSV or POSIX ? */
#include <dirent.h>
#ifdef HAVE_DIRENT_T
    /* nothing */
#else
typedef struct dirent dirent_t;
#endif /* HAVE_DIRENT_T */

#else /* HAVE_DIRENT */
                                    /* no dirent, old BSD ? */
#include <sys/dir.h>
typedef struct direct dirent_t;

#endif /* HAVE_DIRENT */





/*
 * base.c
 */
int   AssignFileName(char *ret, char *path, int cmd);
char *AllocName(char *path,int cmd);

int  ClearDir ( char * path );
int  SetupDir ( char * path);
int  SetupFile(char *nfname, char *name, int filetype, int *nfd);

int  CheckLock ( char * name );
int  Lock(char *name);
int  UnLock(char *name);

int  ExtCmp(char *path, char *ext);
int  IsHTML(char *path);



#endif /* WCOL_BASE_H */
