/*
 * ctree.h - character tree
 *      by k-chinen@is.aist-nara.ac.jp, 1997
 *
 * $Id: ctree.h,v 1.1 1997/09/15 01:59:04 k-chinen Exp k-chinen $
 */

typedef struct _ctree {
    unsigned char label;
    int     term;

    struct _ctree *brother;
    struct _ctree *child;

    void*   value;
} ctree_t;


ctree_t *ctree_new();
int ctree_show(FILE *fp, char *prefix, ctree_t *t);
int ctree_regist(ctree_t *t, char *s, void *v);
int ctree_regist_case(ctree_t *t, char *s, void *v);
void *ctree_search(ctree_t *t, char *ref);
void *ctree_search_case(ctree_t *t, char *ref);


