/*
 *
 *  by k-chinen@is.aist-nara.ac.jp, 1997
 *
 *  $Id: fdio.c,v 1.1 1997/09/15 01:59:18 k-chinen Exp k-chinen $
 */



#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

#ifdef __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif

#include <string.h>
#include <syslog.h>
#include <errno.h>

#include "range.h"
#include "msg.h"



extern int pipe_broken;


#ifdef __STDC__
int fdprintf(const int fd, const char *fmt, ...)
#else
int fdprintf(va_alist)
va_dcl
#endif
{
    va_list args;
#ifndef __STDC__
    int fd;
    char *fmt;
#endif
    char buffer[BUF_SIZE];
    int nwrite;


#ifdef __STDC__
    va_start(args,fmt);
#else
    va_start(args);
    fd  = va_arg(args, int);
    fmt = va_arg(args, char *);
#endif

    vsprintf(buffer, fmt, args);
#if 0
    Trace("<<<%s", buffer);
#endif
try:
    nwrite = write(fd, buffer, strlen(buffer));
    if(pipe_broken) {
        pipe_broken = 0;
    }
    if(nwrite<0) {
        if(errno==EINTR) {
            goto try;
        }
        else {
            Trace("fdprintf: fail write() fd# %d (%d)\n", fd, errno);
        }
    }

    va_end(args);

    return nwrite;
}


static char     gbuf[BUF_SIZE] = "";
static int      gbuf_rest = 0;

char           *fdgets(int fd, char *buf, int n)
{
    char           *ret;
    char            rbuf[256];
    register char  *p, *q;
    int             c;
    int             k;
    int             nread;

#if 0
    Trace("-1 : %d, n %d\n", gbuf_rest, n);
#endif

    memset(buf, '\0', n);


    do {

#if 0
        Trace("0 : %d [%s]\n", gbuf_rest, gbuf);
#endif

        if (gbuf_rest > 0) {
            strcat(buf, gbuf);
            gbuf_rest = 0;
        }

        if (buf[0] != '\0') {

#if 0
            Trace("1 : check\n");
#endif


            p = buf;
            k = 0;
            while (*p && k < n - 2 && (*p != '\n' && *p != '\r')) {
                p++;
                k++;
            }
            if (*p == '\r' || *p == '\n') {

#if 0
                Trace("1 : ok\n");
#endif

                if (*p == '\n') {
                    p++;
                    k++;
                }
                else if (*p == '\r' && *(p + 1) == '\n') {
                    p += 2;
                    k += 2;
                }

                strcpy(gbuf, &buf[k]);
                gbuf_rest = strlen(gbuf);

                buf[k] = '\0';

#if 0
                Trace("1 : %d [%s]\n", gbuf_rest, gbuf);
#endif

                return buf;
            }

#if 0
            Trace("1 : more\n");
#endif

        }
        else {

#if 0
            Trace("1 : skip\n");
#endif
        }

#if 0
    {
        off_t cpos;

        cpos = lseek(fd, 0, SEEK_CUR);
        Trace("fd# %d, pos %ld\n", fd, (long)cpos);
    }
#endif

        nread = read(fd, gbuf, BUF_SIZE);
        if (nread < 0) {
            Trace("read error\n");
            return NULL;
        }
        else {
            gbuf[nread] = '\0';
            gbuf_rest = strlen(gbuf);

#if 0
            Trace("*gbuf :%s*rest: %d\n", gbuf, gbuf_rest);
#endif
        }

    } while (1);

    return NULL;
}






