/*
 *
 *      by k-chinen@is.aistnara.ac.jp 1997
 * $Id: field.c,v 1.1 1997/09/15 01:59:27 k-chinen Exp k-chinen $
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif



#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>


#include "wcol.h"
#include "ctree.h"


ctree_t *RSReq = NULL;      /* Remove Send Request */
ctree_t *RSRes = NULL;      /* Remove Send Response */
ctree_t *CSReq = NULL;      /* Change Send Request */
ctree_t *CSRes = NULL;      /* Change Send Response */
ctree_t *ASReq = NULL;      /* Append Send Request */
ctree_t *ASRes = NULL;      /* Append Send Response */



int CheckFieldMask()
{
    ctree_show(stdout, "RSReq", RSReq);
    ctree_show(stdout, "RSRes", RSRes);
    ctree_show(stdout, "CSReq", CSReq);
    ctree_show(stdout, "CSRes", CSRes);
    ctree_show(stdout, "ASReq", ASReq);
    ctree_show(stdout, "ASRes", ASRes);

    return 0;
}




static char *dummy = "this is dummy";


int AppendRemovedFieldEntry(char *type, char *fname)
{
    ctree_t *t;

    if(type==NULL || *type=='\0' ||
        fname==NULL || *fname=='\0' ) {

        Log("; configuration 'FieldRemove' is wrong");

        return -1;
    }

    if(RSReq==NULL) { RSReq = ctree_new(); }
    if(RSRes==NULL) { RSRes = ctree_new(); }

    if(strcasecmp(type, "SendRequest")==0
        || strcasecmp(fname, "SReq")==0) {
        t = RSReq;
    }
    if(strcasecmp(type, "SendResponse")==0
        || strcasecmp(fname, "SResponse")==0) {
        t = RSRes;
    }

    ctree_regist_case(t, fname, (void*)dummy);

    return 0;
}

int AppendChangedFieldEntry(char *type, char *fname, char *fval)
{
    ctree_t *t;

    if(type==NULL || *type=='\0' ||
        fname==NULL || *fname=='\0' ||
            fval==NULL || *fval=='\0' ) {

        Log("; configuration 'FieldChange' is wrong");

        return -1;
    }

    if(CSReq==NULL) { CSReq = ctree_new(); }
    if(CSRes==NULL) { CSRes = ctree_new(); }

    if(strcasecmp(type, "SendRequest")==0
        || strcasecmp(fname, "SReq")==0) {
        t = CSReq;
    }
    if(strcasecmp(type, "SendResponse")==0
        || strcasecmp(fname, "SResponse")==0) {
        t = CSRes;
    }

    ctree_regist_case(t, fname, (void*)fval);

    return 0;
}

int AppendAppendedFieldEntry(char *type, char *fname, char *fval)
{

    return 0;
}

