/*
 *  WCOL:
 *      by k-chinen@is.aist-nara.ac.jp, 1994, 1995
 *
 *  $Id: global.h,v 1.2 1995/10/09 18:58:42 k-chinen Exp k-chinen $
 */


#ifndef WCOL_GLOBAL_H
#define WCOL_GLOBAL_H


#ifndef DEFAULT_CONFIGFILE
#define DEFAULT_CONFIGFILE      "/etc/wcol.conf"
#endif

#ifndef DEFAULT_POOLDIR
#define DEFAULT_POOLDIR         "/var/tmp/www-pool"
#endif
#ifndef DEFAULT_LOGFILE
#define DEFAULT_LOGFILE         "/var/tmp/wcol.log"
#endif
#ifndef DEFAULT_PIDFILE
#define DEFAULT_PIDFILE         "/var/tmp/wcol.pid"
#endif
#ifndef DEFAULT_STATEFILE
#define DEFAULT_STATEFILE       "/var/tmp/wcol.state"
#endif
#ifndef DEFAULT_GCWORKFILE
#define DEFAULT_GCWORKFILE      "/var/tmp/wcol.gc_work"
#endif
#ifndef DEFAULT_DEBUGLOGDIR
#define DEFAULT_DEBUGLOGDIR     "/var/tmp"
#endif


#if 0


/*
 * internal of global.c
 */
extern pid_t    wcol_pid;
extern int      wcol_request_count;
extern int      debug_flag;
extern int      prefetch_flag;
extern int      mcache_flag;
extern int      catalyst_flag;
extern int      noreaper_flag;
extern int      remove_cookie_flag;


extern url_t    *fetch_parent;
extern url_t    *import_sibling;

extern int      http_listen_portno;
extern int      icp_listen_portno;

extern int      num_handler;
extern int      max_handler;
extern int      num_prompter;
extern int      max_prompter;
extern int      num_speaker;
extern int      max_speaker;

extern char     config_file[];
extern char     state_file[];
extern char     pid_file[];

extern time_t   prefetch_lag_limit;
extern int      num_includedprefetch;
extern int      num_anchorprefetch;

/*
 * external of global.c
 */
extern int      trace_flag;                     /* msg.c */
extern time_t   cache_keeptime;                 /* info.c */
extern time_t   cache_ignorekeeptime;           /* info.c */
extern time_t   cache_locktime;                 /* base.c */
extern char     pool_dir[];
extern char     log_file[];
extern off_t    cache_size;
extern int      cache_use_rate;
extern int      gc_interval;
extern char     gc_workfile[];
extern int      gc_bufsize;


extern  time_t  manager_ref_time;


extern void MarkArgumentsPosition(int arg_num, char **one_arg);
extern int setstring_procesenv(char *astr);


#endif


#endif /* WCOL_GLOBAL_H */


