/*
 *  WCOL: Handler
 *      by k-chinen@is.aist-nara.ac.jp, 1994, 1995, 1996
 *
 *  $Id: handler.h,v 1.1 1995/10/09 10:27:55 k-chinen Exp k-chinen $
 */

#ifndef WCOL_HANDLER_H
#define WCOL_HANDLER_H


#define HREP_UNKNOW         (0)
#define HREP_CACHEHIT       (1)
#define HREP_CACHESAME      (2)
#define HREP_SERVERACCESS   (3)
#define HREP_SUCCESSPOST    (4)
#define HREP_SERVERERROR    (5)
#define HREP_IGNOREREQUEST  (6)
#define HREP_INNERERROR     (7)
#define HREP_INT            (8)
#define HREP_TIMEOUT        (9)


typedef struct {
    int         type;
    int         sid;
    int         id;
    int         keep_alive; /* keep alive or not */
    off_t       diff;       /* differences for cache */

    request_t   req;
} hreport_t;


typedef request_t mrequest_t;



#define HRepTypeStr(v) ((v>=HREP_CACHEHIT&&v<=HREP_TIMEOUT) ? \
            _hrep_type_str[v] : _hrep_type_str[HREP_UNKNOW])


extern char *_hrep_type_str[];

void ShowHReport(hreport_t *hrep);



#endif /* WCOL_HANDLER_H */

