/*
 *  WCOL: HTTP procedures
 *      by k-chinen@is.aist-nara.ac.jp, 1994, 1995
 *
 *  $Id: http.h,v 1.3 1995/10/09 10:26:48 k-chinen Exp k-chinen $
 */

#ifndef WCOL_HTTP_H
#define WCOL_HTTP_H     /* block for forever(or nest) loop */

#define HTTP_PORTNO             (80)

#define HTTP_V_0                "HTTP/0"
#define HTTP_V_1_0              "HTTP/1.0"
#define HTTP_V_1_1              "HTTP/1.1"

#define HTTP_HEADER_SIZE        (2047)


int     HTTP_ErrorMessage_Old(int fd, int err_no,
            char *smessage, char *lmessage, int http1);

int     HTTP_ErrorMessage(int fd, int major_ver, int minor_ver,
            int err_no, char *smessage, char *fmt, ...);
#if 0
int     HTTP_ErrorMessage_0(int fd,
            int err_no, char *smessage, char *fmt, ...);
int     HTTP_ErrorMessage_1(int fd,
            int err_no, char *smessage, char *fmt, ...);
#endif

int     HTTP_Request(int fd, char *url,  char *auth);
int     HTTP_NewRequest(int fd, char *host, char *path,
                    char *auth, char *cookie, int nocache ,int noprefetch);
int     HTTP_CookedRequest(int fd, int nocache, char *host, char *path,
                    char *rbuf);

time_t  Parse_HTTP_date(char *line);
int     HTTP_ParseRequest(int sock_fd, request_t *req, char *req_cont);
int     HTTP_Get(int *client_fd, char *name,
            int keep_alive, int nocache, int noprefetch,
            int istate,
            char *servername, int port, char *path, char *auth,  Info **val);

#endif /* WCOL_HTTP_H */
