/*
 *  WCOL: Japanese Filter procedures
 *      by k-chinen@is.aist-nara.ac.jp, 1994, 1995
 *
 *  $Id: jfilter.h,v 1.1 1995/12/04 17:15:44 k-chinen Exp k-chinen $
 */

/*
 *  There are 3 major japanese code. These are called JIS, SJIS and EUC.
 *  In generally, People use JIS code (what is known as ISO-2022-JP) in
 *  HTML. But several OS cannot handle JIS, Then we need convertor.
 *  This procedures are a kind of answer for that problem.
 */

#ifndef WCOL_JFILTER_H
#define WCOL_JFILTER_H

/*
 * If you want test, please compile with -DJFILETER_TEST.
 */
#ifndef BUF_SIZE
#define BUF_SIZE 10240
#endif

/*
 * bind number to CODEs
 */

#ifndef JIS_CODE
#define JIS_CODE    (0)
#define EUC_CODE    (1)
#define SJIS_CODE   (2)
#endif /* !JIS_CODE */


/* checkers */
int CheckKanjiCode (char *buf );
int CheckFileKanjiCode (char *filename ,int linelimit );

/* convertors */
int ToEUC (int icode ,int ifd ,int ofd );
int ToSJIS (int icode ,int ifd ,int ofd );
int ToJIS (int icode ,int ifd ,int ofd );

#endif

