/*
 *  WCOL: main - initialize and call Manager.
 *      by k-chinen@is.aist-nara.ac.jp, 1995, 1996
 *
 *  $Id: main.c,v 1.12 1996/03/25 05:24:32 k-chinen Exp k-chinen $
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <signal.h>
#include <setjmp.h>
#ifdef HAVE_SYS_WAIT_H
#include <sys/wait.h>
#endif
#include <sys/uio.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <limits.h>
#include <errno.h>

#include "wcol.h"
#include "args.h"
#include "ipc.h"
/*
#include "request.h"
#include "handler.h"
*/
#include "sigs.h"
#include "global.h"



#if 1
pid_t wcol_pid;
int catalyst_flag;
int noreaper_flag;
#endif




/*
 * Re configuration when catch HUP.
 */
RETSIGTYPE ReConfig()
{
    Log("; Reconfigure - read configuration file");

    ReadConfigFile(config_file);
    FixGlobals();

    ShowGlobals(stdout);
}










/*
 * default (constants or MACROs) -> config-file -> commandline
 */
void Init(int argc, char **argv)
{
    /*
     *
     */
    SetGlobalDefaults();
    if(getenv(DEFAULT_CONFIG_ENVNAME)!=NULL) {
        strcpy(config_file, getenv(DEFAULT_CONFIG_ENVNAME));
    }
    ReadConfigFile(config_file);
    ReadCommandlineOptions(argc, argv);

    /*
     *
     */
    FixGlobals();
    if(trace_flag) {
        ShowGlobals(stdout);
    }

    InitLogger("wcol-Ealpha");
}


extern RETSIGTYPE TrapChildDie();



void main(int argc, char **argv)
{
    Init(argc, argv);

    SetSignalHandler(SIGHUP,    ReConfig);
#if 0
    SetSignalHandler(SIGCHLD,   ReleseChild);       /* generally */
#endif
    SetSignalHandler(SIGCHLD,   TrapChildDie);      /* specail for manager */
    SetSignalHandler(SIGPIPE,   PipeErrorHandler);
    /*
    SetSignalHandler(SIGTERM, RelesePort);
    */


    /*
     * In order to flush log, insert dummy message.
     */
    Log("; I am ready. Are you ready ?");


    DLog("START %s %s %s", WCOL_VER, WCOL_INFO_ID,
            catalyst_flag ? "CATALYST" : "PROXY" );

    ManagerSetup();
    Manager();

    exit(WCOL_EXIT_NORMAL);
}


