/*
 *  WCOL: Manager
 *      by k-chinen@is.aist-nara.ac.jp, 1994, 1995
 *
 *  $Id: manager.h,v 1.2 1996/11/26 01:00:42 k-chinen Exp k-chinen $
 *
 */
#ifndef WCOL_MANAGER_H
#define WCOL_MANAGER_H

#if 0
#ifndef HAVE_FDSET_T
#ifdef  HAVE_TYPEDEF_FD_SET
typedef fd_set          fdset_t;
#else
typedef struct fd_set   fdset_t;
#endif  /* HAVE_TYPEDEF_FD_SET */
#define HAVE_FDSET_T
#endif  /* HAVE_FDSET_T */
#endif

#ifndef MAX_HANDLER
#define MAX_HANDLER     16
#endif
#ifndef MAX_PROMPTER
#define MAX_PROMPTER    2
#endif
#ifndef MAX_SPEAKER
#define MAX_SPEAKER     2
#endif



#ifndef WCOL_FD_MAX
#ifndef FD_SETSIZE
#define WCOL_FD_MAX         (MAX_HANDLER+MAX_PROMPTER+MAX_SPEAKER+10)
#else
#define WCOL_FD_MAX         FD_SETSIZE
#endif
#endif /* WCOL_FD_MAX */



#define WCOL_MOD_UNKNOW     0
#define WCOL_MOD_MANAGER    1
#define WCOL_MOD_REAPER     2
#define WCOL_MOD_HANDLER    3
#define WCOL_MOD_PROMPTER   4
#define WCOL_MOD_SPEAKER    5


typedef struct  {
    int     wake;               /* wake or not */
    int     busy;               /* busy or not */
    int     times;              /* how many request(s) processed */
    pid_t   pid;                /* process id */
    int     port;               /* port to command dispatching */
    time_t  start;              /* dispatch date/time */

    int     mode;               /* mode (request or prefetch) */
    request_t req;              /* request */
#if 0
    char    url[INFONAMESIZE];  /* url */
#endif

    int     z_req;              /* total number of requests */
    int     z_sess;             /* total number of sessions */

} modinfo_t;


typedef struct {
    int         type;
    modinfo_t   *mod;
} fd2mod_t;


extern char *_mod_type_str[];

#define ModTypeStr(v) ((v>=WCOL_MOD_UNKNOW&&v<=WCOL_MOD_SPEAKER) ? \
                    _mod_type_str[v] : _mod_type_str[WCOL_MOD_UNKNOW])



#ifndef REQUEST_LIMITTIME
#define REQUEST_LIMITTIME 30*60 /* 30 min. */
#endif


extern fdset_t  manager_fdset;
extern fd2mod_t fd2mod[];


/*
 * handlers (HTTP connection)
 */
extern int        num_handler;
extern modinfo_t  *handlers;

extern int launch_handler();
extern int launch_handlers(int req);



/*
 * prompter (HTML parse, generate inner request)
 */
extern int        num_prompter;
extern modinfo_t  *prompters;

extern int launch_prompter();
extern int launch_prompters(int req);



#endif /* WCOL_MANAGER_H */

