/*
 *  WCOL: Message procedures (for loggin and debug)
 *      by k-chinen@is.aist-nara.ac.jp, 1994, 1995
 *
 * $Id: msg.h,v 1.3 1995/10/09 10:51:50 k-chinen Exp k-chinen $
 */

#ifndef WCOL_MSG_H
#define WCOL_MSG_H


/* When facility is not specifyed, set it as LOG_DAEMON */
#ifndef LOG_FACILITY
#define LOG_FACILITY LOG_DAEMON
#endif

#ifndef LOG_LINESIZE
#define LOG_LINESIZE        1024
#endif
#ifndef LOG_FILENAMESIZE
#define LOG_FILENAMESIZE    512
#endif

#ifdef __STDC__
int InitLogger(char *name);
int RawTrace(const char *fmt, ...);
int Log(const char *fmt, ...);
int DLog(const char *fmt, ...);
int Error(const char *fmt, ...);
int Fatal(const char *fmt, ...);
int SwitchLog(char *logpath, char *note);
#else
int InitLogger();
int RawTrace();
int Log();
int DLog();
int Error();
int Fatal();
int SwitchLog();
#endif



/* warp function with trace_flag checking */
#define Trace if(trace_flag) RawTrace


extern int trace_flag;

#endif /* WCOL_MSG_H */

