/*
 *  WCOL: retreive path by URL
 *      by k-chinen@is.aist-nara.ac.jp, 1996
 *
 *  $Id: plist.c,v 1.1 1996/11/11 14:38:49 k-chinen Exp k-chinen $
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/uio.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <limits.h>
#include <time.h>
#ifdef TIME_WITH_SYS_TIME
#include <sys/time.h>
#endif
#include <signal.h>
#include <errno.h>
#ifdef HAVE_SYS_SELECT_H
#include <sys/select.h>
#endif
#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif

#include <math.h>

#include "wcol.h"
#include "msg.h"
#include "request.h"
#include "ipc.h"
#include "reaper.h"
/*
#include "sigs.h"
#include "global.h"
*/




void Init(int argc, char **argv)
{
    SetGlobalDefaults();
    if(getenv(DEFAULT_CONFIG_ENVNAME)!=NULL) {
        strcpy(config_file, getenv(DEFAULT_CONFIG_ENVNAME));
    }
    ReadConfigFile(config_file);

    ReadCommandlineOptions(argc, argv);
}



extern char *Chop_CRLF(char *line);

url_trans(FILE *ifp, FILE *ofp)
{
    char s_url[STRING_SIZE], d_path[STRING_SIZE];
    url_t url;

    URL_Clear(&url);

    fprintf(ofp, "; raw-URL\tnormalized-URL\tcache-path\n");

    while(fgets(s_url, STRING_SIZE, ifp)!=NULL) {
        Chop_CRLF(s_url);
#if 0
        fprintf(ofp, "%s ", s_url);
        if(AssignFileName(d_path, s_url, BODY_FILE)) {
            fprintf(ofp, "\n");
        }
        else {
            fprintf(ofp, "%s\n", d_path);
        }
#endif

        URL_Reset(&url);
        URL_Set(&url, s_url);
        URL_Normalize(&url);
#if 0
        URL_Show(&url);
#endif

        if(AssignURLToFileName(d_path, &url, BODY_FILE)) {
            fprintf(ofp, "%s\t%s\n", s_url, url.full_loc);
        }
        else {
            fprintf(ofp, "%s\t%s\t%s\n", s_url, url.full_loc, d_path);
        }
    }

    URL_Reset(&url);
}



main(int argc, char **argv)
{
    Init(argc, argv);

    url_trans(stdin, stdout);
}
