/*
 *  WCOL: misc. procedures for sessions
 *      by k-chinen@is.aist-nara.ac.jp, 1996, 1997
 *
 *  $Id$
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#ifdef HAVE_SYS_WAIT_H
#include <sys/wait.h>
#endif
#include <sys/uio.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <limits.h>

#include <sys/ipc.h>
#include <sys/shm.h>


#ifdef HAVE_SYS_SELECT_H
#include <sys/select.h>
#endif

#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif

#ifndef ESC
#define ESC '\x1b'
#endif


#include <signal.h>
#include <errno.h>

#include "wcol.h"
#include "msg.h"
#include "request.h"
#include "ipc.h"
#include "sigs.h"
#include "fds.h"

#include "session.h"


char *SessPhaseStr(Session_phase ph)
{
    switch(ph) {
    case PHASE_UNKNOW:          return "unknow";
    case PHASE_IDLE:            return "Idle";
    case PHASE_START:           return "start";
    case PHASE_REQUEST:         return "Request";
    case PHASE_THINK:           return "think";
    case PHASE_WAIT:            return "Wait";
    case PHASE_SEND:            return "Send";
    case PHASE_QUERY:           return "Query";
    case PHASE_NAMERESOLV:      return "Resolv";
    case PHASE_CONNECTSERVER:   return "Connect";
    case PHASE_CONNECTSIBLING:  return "Sibling";
    case PHASE_HEADER:          return "Head";
    case PHASE_BODY:            return "Body";
    case PHASE_END:             return "end";
    case PHASE_ERROR:           return "Error";
    default:                    return "OTHER";
    }
}

char SessPhaseChar(Session_phase ph)
{
    switch(ph) {
    case PHASE_UNKNOW:          return 'u';
    case PHASE_IDLE:            return 'I';
    case PHASE_START:           return 's';
    case PHASE_REQUEST:         return 'R';
    case PHASE_THINK:           return 't';
    case PHASE_WAIT:            return 'W';
    case PHASE_SEND:            return 'S';
    case PHASE_QUERY:           return 'Q';
    case PHASE_NAMERESOLV:      return 'n';
    case PHASE_CONNECTSERVER:   return 'C';
    case PHASE_CONNECTSIBLING:  return 'N';
    case PHASE_HEADER:          return 'H';
    case PHASE_BODY:            return 'B';
    case PHASE_END:             return 'e';
    case PHASE_ERROR:           return 'E';
    default:                    return '?';
    }
}


char SessTypeStr(Session_type pt)
{
#if 0
    switch(pt) {
    case REQ_UNKNOWMODE:        return 'U';
    case REQ_CLIENT:            return 'C';
    case REQ_PREFETCH:          return 'P';
    case REQ_IMPORT:            return 'I';
    default:                    return '?';
    }
#else
    switch(pt) {
    case SESS_NOP:              return '_';
    case SESS_CLIENT:           return 'C';
    case SESS_PREFETCH:         return 'P';
    case SESS_IMPORT:           return 'I';
    default:                    return '?';
    }
#endif
}

